
knockback = 10000
speed = 2200
box = {}

--TEST IF THE PLAYER IS AGAINST THE WALL, AND IF HE IS  AND HE GETS HIT, THEN MOVE HIM AWAY
function box:spawn(x,y,color)
	table.insert(box, {x = x, y = y, health = 50,yfriction = 1.5,friction = 3.5,color = color, xvel = 0, width = 50, height = 50, yvel = 0,rightcol = false,leftcol = false,topcol = false,bottomcol = false})
end
function box:draw()
	for i,v in ipairs(box) do
		if v.color == "red" then
			love.graphics.setColor(255,0,0)
		end
		if v.color == "blue" then
			love.graphics.setColor(0,0,255)
		end
		love.graphics.rectangle("fill",v.x,v.y,v.width,v.height)
	end
end
function box:move(dt)
	for i,v in ipairs(box) do
		v.x = v.x + v.xvel * dt
		v.y = v.y + v.yvel * dt
		v.xvel = v.xvel * (1 - math.min(dt*v.friction, 1))
		v.yvel = v.yvel * (1 - math.min(dt*v.yfriction, 1))


		if v.health < 1 then
			table.remove(box, i)
		end

		if v.x < 0 then
			v.x = 0
			v.xvel = -v.xvel / 2
		end
		if v.x + v.width > love.graphics.getWidth() then
			v.x = love.graphics.getWidth() - v.width
		end
		if v.y < 0 then
			v.y = 0
			v.yvel = -v.yvel / 2
		end
		if v.y + v.height > love.graphics.getHeight() then
			v.y = love.graphics.getHeight() - v.height
			v.yvel = - v.yvel / 2
		end
		if v.x == 0 then
			v.leftcol = true
		end
		if v.x == love.graphics.getWidth() - v.width then
			v.rightcol = true
		end
		if v.y == love.graphics.getHeight() - v.height then
			v.bottomcol = true
		end
		if v.y == 0 then
			v.topcol = true
		end	


		if v.xvel > 2000 then
			v.xvel = 2000
		end
		if v.xvel < -2000 then
			v.xvel = -2000
		end
		if v.yvel > 2000 then
			v.yvel = 2000
		end
		if v.yvel < -2000 then
			v.yvel = -2000
		end
		for ia,va in ipairs(box) do
			if va.x + (va.width / 2) < v.x + (v.width / 2) then
				if va.color == "blue" and
				v.color == 'red' then

					v.xvel = v.xvel - speed * dt
				end
				if va.color == "red" and
				v.color == "blue" then
					v.xvel = v.xvel - speed * dt
				end
			end
			if va.y + (va.height / 2) > v.y + (v.height / 2) then
				if va.color == "blue" and
				v.color == 'red' then
					v.yvel = v.yvel + speed * dt
				end
				if va.color == "red" and
				v.color == 'blue' then
					v.yvel = v.yvel + speed * dt
				end
			end
			if va.y + (va.height / 2) < v.y + (v.height / 2) then
				if va.color == "blue" and
				v.color == 'red' then
					v.yvel = v.yvel - speed * dt
				end
				if va.color == "red" and
				v.color == 'blue' then
					v.yvel = v.yvel - speed * dt
				end
			end

			if va.x + (va.width / 2) > v.x + (v.width / 2) then
				if va.color == "blue" and
				v.color == 'red' then
					v.xvel = v.xvel + speed * dt
				end
				if va.color == "red" and
				v.color == 'blue' then
					v.xvel = v.xvel + speed * dt
				end
			end
			if v.x + v.width > va.x and
			v.x < va.x + va.width and
			v.y + v.height > va.y and
			v.y < va.y + va.height then
				
				if v.x + (v.width / 2) < va.x + (va.width / 2) then
					if va.color == "blue" and
					v.color == 'red' then
					v.health = v.health - 1
					v.xvel = v.xvel - knockback * dt
					va.xvel = va.xvel + knockback * dt
					end
					if va.color == "red" and
					v.color == 'blue' then
					v.health = v.health - 1
					v.xvel = v.xvel - knockback * dt
					va.xvel = va.xvel + knockback * dt
					end
				end
				if v.x + (v.width / 2) > va.x + (va.width / 2) then
					if va.color == "red" and
					v.color == 'blue' then
					v.health = v.health - 1
					v.xvel = v.xvel + knockback * dt
					va.xvel = va.xvel - knockback * dt
					end
					if va.color == "blue" and
					v.color == 'red' then
					v.health = v.health - 1
					v.xvel = v.xvel + knockback * dt
					va.xvel = va.xvel - knockback * dt
					end
				end
				if v.y + (v.height / 2) > va.y + (va.height / 2) then
					if va.color == "red" and
					v.color == 'blue' then
					v.health = v.health - 1
					v.yvel = v.yvel + knockback * dt
					va.yvel = va.yvel - knockback * dt
					end
					if va.color == "blue" and
					v.color == 'red' then
					v.health = v.health - 1
					v.yvel = v.yvel + knockback * dt
					va.yvel = va.yvel - knockback * dt
					end
				end
				if v.y + (v.height / 2) > va.y + (va.height / 2) then
					if va.color == "blue" and
					v.color == 'red' then
					v.health = v.health - 1
					v.yvel = v.yvel - knockback * dt
					va.yvel = va.yvel + knockback * dt
					end
					if va.color == "red" and
					v.color == 'blue' then
					v.health = v.health - 1
					v.yvel = v.yvel - knockback * dt
					va.yvel = va.yvel + knockback * dt
					end
				end
				if v.x + (v.width / 2) == va.x + (va.width / 2) then
					if va.color == "blue" and
					v.color == 'red' then
						v.health = v.health - 1
						v.xvel = v.xvel - knockback * dt
					end
					if va.color == "red" and
					v.color == "blue" then
						v.health = v.health - 1
						v.xvel = v.xvel - knockback * dt
					end
				end
			end
		end
	end
end	
function box:spawnwith(key)
	if key == "right" then
		math.randomseed(os.time())
		math.random()
		math.random()
		math.random()
		box:spawn(love.graphics.getWidth() - 50, math.random(0,love.graphics.getHeight() - 50),'red')
		math.randomseed(os.time())
		math.random()
		math.random()
		math.random()
	end
	if key == "left" then
		math.randomseed(os.time())
		math.random()
		math.random()
		math.random()
		box:spawn(0, math.random(0,love.graphics.getHeight() - 50),'blue')
		math.randomseed(os.time())
		math.random()
		math.random()
		math.random()
	end
end


local alpha = 255
local alphatimer = 0
function play_text(dt)
	if gamestate == "playing" then
		alphatimer = alphatimer + dt
	end
	if gamestate == "menu" then
		alphatimer = 0
		alpha = 255
	end
	if alphatimer > 1 then
		if alpha > 1 then
			alpha = alpha - 200 * dt
		end
		if alpha < 1 then
			alpha = 1
		end
	end
end
function play_textDraw()
	love.graphics.setColor(0,0,0,alpha)
	love.graphics.setFont(title)
	love.graphics.print('Start!',love.graphics.getWidth() / 2 - (title:getWidth('Start!') / 2), love.graphics.getHeight() / 2 - (medium:getHeight() / 2))
end


