require "sound"
require "boxes"
require "menu"


function love.load()


	--Fonts
	small = love.graphics.newFont('fonts/arcade.ttf',24)
	medium = love.graphics.newFont('fonts/arcade.ttf',37)
	large = love.graphics.newFont('fonts/arcade.ttf',54)

	load_menu = true


	gamestate = "menu"

	love.graphics.setBackgroundColor(255,255,255)
	menu_loading = true
end
function love.update(dt)
	mousex = love.mouse.getX()
	mousey = love.mouse.getY()

	menu_load()
	play_text(dt)
	
	if gamestate == "playing" then
		box:move(dt)
	end
	if gamestate == "menu" then
		button:check()
	end

end
function love.mousepressed(x,y)
	 if gamestate == "menu" then
	 	button:click(x,y)
	 end
end
function love.keypressed(key)
	if gamestate == "playing" then
		box:spawnwith(key)
	end
	if key == "r" then
		for i=0,#box do
			table.remove(box, i)
		end
	end
end
function love.draw()
	if gamestate == "playing" then
		love.graphics.setFont(small)
		love.graphics.setColor(0,0,0)
		love.graphics.print(#box,0,0)
	end
	if gamestate == "playing" then
		box:draw()
		play_textDraw()
	end
	if gamestate == "menu" then
		button:draw()
		menu_draw()
	end
	

end