

button = {}

function button:spawn(x,y,text,id)
	table.insert(button, {x = x, y = y, text = text, id = id,red = 0,green = 0, blue = 0})
end
function button:draw()
	for i,v in ipairs(button) do
		love.graphics.setColor(v.red,v.green,v.blue)
		love.graphics.setFont(medium)
		love.graphics.print(v.text,v.x,v.y)
	end
end
function button:click(x,y)
	
		gamestate = "playing"
	
	for i,v in ipairs(button) do
		if x > v.x and
		x < v.x + medium:getWidth(v.text) and
		y > v.y and
		y < v.y + medium:getHeight() then
			TEsound.play(click)
			if v.id == "start" then
				gamestate = "playing"
			end
			if v.id == "quit" then
				love.event.quit()
			end
		end
	end
end
function button:check()
	for i,v in ipairs(button) do
		if mousex > v.x and
		mousex < v.x + medium:getWidth(v.text) and
		mousey > v.y and
		mousey < v.y + medium:getHeight() then
			v.red = 100
			v.green = 100
			v.blue = 100
		else
			v.red = 0
			v.green = 0
			v.blue = 0
		end
	end
end

function menu_load()
	if load_menu == true then
		button:spawn(love.graphics.getWidth() / 2 - (medium:getWidth('Start') / 2),175,'Start','start')
		button:spawn(love.graphics.getWidth() / 2 - (medium:getWidth('Quit') / 2),400,'Quit','quit')

		load_menu = false
	end
end

title = love.graphics.newFont('fonts/ill.ttf',27)
function menu_draw()
	love.graphics.setFont(title)
	love.graphics.setColor(0,0,0)
	love.graphics.print("Block Fighter X-treme 2000: Deluxe Edition V2.0",love.graphics.getWidth() / 2 - title:getWidth('Block Fighter X-treme 2000: Deluxe Edition V2.0') / 2, 5)
end	










